'use strict';

exports.__esModule = true;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _reactRedux = require('react-redux');

var _reactRouterRedux = require('react-router-redux');

var _auth = require('../auth0');

var _pure = require('./pure');

var _pure2 = _interopRequireDefault(_pure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var localStorage = window.localStorage;

var Auth0 = function (_Pure) {
  (0, _inherits3.default)(Auth0, _Pure);

  function Auth0() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Auth0);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _Pure.call.apply(_Pure, [this].concat(args))), _this), _this._authenticated = function (authResult) {
      var _this$props = _this.props,
          push = _this$props.push,
          setAuth0User = _this$props.setAuth0User;

      _auth.lock.getProfile(authResult.idToken, function (error, profile) {
        if (error) {
          setAuth0User(null);
          push('/login');
        } else {
          var user = (0, _extends3.default)({}, authResult, {
            profile: profile
          });
          localStorage.setItem('user', (0, _stringify2.default)(user));
          setAuth0User(user);
          push('/');
        }
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  Auth0.prototype.componentDidMount = function componentDidMount() {
    // when testing, auth0 credentials are not currently entered, so `lock` will be null
    if (_auth.lock) {
      _auth.lock.show();
      _auth.lock.on('authenticated', this._authenticated);
    }
  };

  Auth0.prototype.render = function render() {
    return null;
  };

  return Auth0;
}(_pure2.default);

Auth0.propTypes = {
  push: _react.PropTypes.func.isRequired,
  setAuth0User: _react.PropTypes.func.isRequired
};


function mapStateToProps(state) {
  return state;
}
var mapDispatchToProps = {
  push: _reactRouterRedux.push,
  setAuth0User: _auth.setAuth0User
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Auth0);
module.exports = exports['default'];

//# sourceMappingURL=auth0-lock.js